/* 
 * Copyright (c) 2010, Texas Instruments Incorporated
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * *  Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * *  Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * *  Neither the name of Texas Instruments Incorporated nor the names of
 *    its contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
 * OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
 * EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 */
metaonly module System {

    // this is what the command below returns
    struct RunResult {
        int    status;
        string stdout;
        string stderr;
        string stdsys;
    };

    // commandStr is any sh-style shell command
    //     possibly a series of commands chained with pipes
    // cbPrint is a callback function that collects the execution log
    // detailLevel can be 0..3, determins what part of stdout gets printed
    //     through cbPrint; 2 prints all stdout, 3 prints environment as well
    RunResult runShellCommand( String commandStr, any cbPrint, int detailLevel );

    // name of any executable that's about to be invoked should be run through
    // this function first; it will correct the slashes, and in the case of
    // common tools like "grep" decide if they come from a utility dir (Win)
    // or from the system (Linux)
    string getCommandPath( string command );
    string checkPath( string path );
}
/*
 *  @(#) ti.xdais.qualiti; 1, 0, 0,102; 5-4-2010 08:46:17; /db/wtree/library/trees/dais/dais-q11x/src/
 */

